require 'optparse'

module Steppable
  class << self
    def opt
      @_opt ||= OptionParser.new
    end
  end

  def example_step(n, desc=nil, &block)
    Steppable.opt.on("--step-#{n}", desc || "Run the step #{n}", &block)
  end
  alias register_step example_step
end

at_exit do
  Steppable.opt.parse!(ARGV)
end

self.send :extend, Steppable
